---
title: URLSearchParams()
slug: Web/API/URLSearchParams/URLSearchParams
tags:
  - API
  - Constructor
  - Reference
  - URL API
  - URLSearchParams
---
<p>{{ApiRef("URL API")}}</p>

<p>The <code><strong>URLSearchParams()</strong></code> constructor creates and returns a new {{domxref("URLSearchParams")}} object.</p>

<p>{{availableinworkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>URLSearchParams</em> = new URLSearchParams(<em>init</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<p><em><code>init</code></em> {{optional_inline}}</p>

<p>One of:</p>

<ul>
 <li>A {{domxref("USVString")}}, which will be parsed from <code>application/x-www-form-urlencoded</code> format. A leading <code>'?'</code> character is ignored.</li>
 <li>A sequence of {{domxref("USVString")}} pairs, representing names/values.</li>
 <li>A record of {{domxref("USVString")}} keys and {{domxref("USVString")}} values.</li>
</ul>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("URLSearchParams")}} object instance.</p>

<h2 id="Examples">Examples</h2>

<p>The following example shows how to create a {{domxref("URLSearchParams")}} object from a URL string.</p>

<pre class="brush: js">// Retrieve params via url.search, passed into ctor
var url = new URL('https://example.com?foo=1&amp;bar=2');
var params = new URLSearchParams(url.search);

// Pass in a string literal
var params2 = new URLSearchParams("foo=1&amp;bar=2");
var params2a = new URLSearchParams("?foo=1&amp;bar=2");

// Pass in a sequence of pairs
var params3 = new URLSearchParams([["foo", "1"], ["bar", "2"]]);

// Pass in a record
var params4 = new URLSearchParams({"foo": "1", "bar": "2"});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('URL', '#dom-urlsearchparams-urlsearchparams', "URLSearchParams()")}}</td>
   <td>{{Spec2('URL')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.URLSearchParams.URLSearchParams")}}</p>
</div>
